/**********************************************************************
 *HY16F188
 * main.c
 * Created on:2013/12/08
 * Maintenance:2014/10/01
 * --------------------------------------------------------------------
 * Release 1.0.0
 * Program Description:
 * --------------------
 *
 * ---------
 *          |              --------------------
 *    PT2.0 | SDA ---> SDA | LCD Drive HY2613 |
 *    PT2.1 | SCK ---> SCK --------------------
 *     GND  |
 *          |
 * ---------
 **********************************************************************/
/*----------------------------------------------------------------------------*/
/* Includes                                                                   */
/*----------------------------------------------------------------------------*/
#include "HY16F188.h"
#include "System.h"
#include "DrvGPIO.h"
#include "DrvI2C.h"
#include "DrvHWI2C.h"
#include "DrvCLOCK.h"
#include "DrvADC.h"
#include "DrvPMU.h"
#include "HY2613.h"
#include "my define.h"

/*----------------------------------------------------------------------------*/
/* STRUCTURES                                                                 */
/*----------------------------------------------------------------------------*/
typedef union _MCUSTATUS
{
  char  _byte;
  struct
  {
    unsigned b_ADCdone:1;
    unsigned b_TMAdone:1;
    unsigned b_TMBdone:1;
    unsigned b_TMC0done:1;
    unsigned b_TMC1done:1;
    unsigned b_RTCdone:1;
    unsigned b_UART_TxDone:1;
    unsigned b_UART_RxDone:1;
  };
} MCUSTATUS;

/*----------------------------------------------------------------------------*/
/* DEFINITIONS                                                                */
/*----------------------------------------------------------------------------*/


/*----------------------------------------------------------------------------*/
/* Global CONSTANTS                                                           */
/*----------------------------------------------------------------------------*/
MCUSTATUS  MCUSTATUSbits;
extern unsigned char seg[16];
#define  Disable 0
#define  Enable  1
int key_ck,b,c,pb6,pb7;			//
signed int ADtemp10,ADCData,sum,ADtemp101,ADtemp100,average;//AD
signed int ADtemp20n,ADtemp20p,ADtemp200,ADtemp110n,ADtemp110p,ADtemp1100; //pܥ
int nu,tn,ch,ok;															//P_
int value_buf[9];
/*----------------------------------------------------------------------------*/
/* Function PROTOTYPES                                                        */
/*----------------------------------------------------------------------------*/
void Delay(unsigned int num);
void InitalADC(void);
void Initial_ALL(void);
void Pb_6();
void Pb_7();
void AD3(void);
void Test1(void);
void Test2(void);
void AD01(void);
/*----------------------------------------------------------------------------*/
/* Main Function                                                              */
/*----------------------------------------------------------------------------*/
int main(void)
{
    InitalI2C();
    SYS_EnableGIE(7,0x3F);  // Enable GIE(Global Interrupt)

    Ini_Display();
    ClearLCDframe();

	InitalADC();
	Initial_ALL();

    MCUSTATUSbits._byte = 0;
    while(1)															//D{}l
    {
  	  pb7=0;
  	  LCD_DATA_DISPLAY2(key_ck);									//ܲ{b
  	  if(b==0) Pb_6();												//S3O_UAU檬A+1
  	  if(pb6==1)
  	  {
  		  pb6=0;
  		  key_ck++;
  		  Delay(0x2000);
  		  if(key_ck>=3) key_ck=1;
  	  }
  	  if(c==0) Pb_7();												//S2O_UAUhiJӿն
  	  if(pb7==1)
  	  {
  		  pb7=0;
  		  switch(key_ck)
  		  {
  		  	  case 0x01:Test1();break;//*20V						//Is20VqqƵ{
  		  	  case 0x02:Test2();break;//*110mA						//Is110mAqyqƵ{
  		  }
  	  }
    }


  return 0;
}
void Test1(void)													//20VqqƵ{
{
	 while(DrvGPIO_GetBit(E_PT1,7))									//US2ɱN|}Ƶ{
	  {
		 AD3();														//IstqPwƵ{
		 key_ck=0;													//OXhɿ檬A0
		 if(nu==0)													//JA
		 {
			 AD01();												//IsADƵ{
			 if(sum<7010)
			 {sum=sum-1;
			 ADtemp101=100*(sum-ADtemp200)/(ADtemp20n-ADtemp200);
			 ADtemp100=ADtemp101%100;
			 if(ADtemp100>70) ADtemp101+=100;
			 ADtemp101=ADtemp101/100;
			 ADtemp101=ADtemp101*10;
			 LCD_DATA_DISPLAY(ADtemp101);							//q
			 }
			 else
			 {
				 if(sum<10507)
				 {
					 sum-=1;
					 ADtemp101=(sum-ADtemp200)/(ADtemp20n-ADtemp200);
					 ADtemp101*=10;
				 }
				 else
				 {
					 sum-=3;
					 ADtemp101=(sum-ADtemp200)/(ADtemp20n-ADtemp200);
					 ADtemp101*=10;
				 }
				 LCD_DATA_DISPLAY(ADtemp101);
			 }
		 }
		 if(nu==1)													//Xtq
		 {
			 AD01();												//IsADƵ{
			 if(sum<7010)
			 {sum=sum-1;
			 ADtemp101=100*(sum+ADtemp200)/(ADtemp20n+ADtemp200);
			 ADtemp100=ADtemp101%100;
			 if(ADtemp100>70) ADtemp101+=100;
			 ADtemp101=ADtemp101/100;
			 ADtemp101=ADtemp101*10;
			 LCD_DATA_DISPLAY(ADtemp101);							//q
			 }
			 else
			 {
				 if(sum<10507)
				 {
					 sum-=1;
					 ADtemp101=(sum+ADtemp200)/(ADtemp20n+ADtemp200);
					 ADtemp101*=10;
				 }
				 else
				 {
					 sum-=3;
					 ADtemp101=(sum+ADtemp200)/(ADtemp20n+ADtemp200);
					 ADtemp101*=10;
				 }
				 LCD_DATA_DISPLAY(ADtemp101);
			 }
		 }
	  }
	  Delay(0x2000);
}
/*----------------------------------------------------------------------------*/
void Test2(void)													//110mAqyqƵ{
{

	 while(DrvGPIO_GetBit(E_PT1,7))									//US2ɱN|}Ƶ{
	  {
		 AD3();														//IstqPwƵ{
		 key_ck=0;													//OXhɿ檬A0
		 if(nu==0)													//JA
		 {
			 AD01();												//IsADƵ{
			 ADtemp101=100*(sum+1)/(ADtemp110n-ADtemp1100);			//ƭȹB
			 LCD_DATA_DISPLAY1(ADtemp101);							//q
		 }
		 if(nu==1)
		 {
			 AD01();
			 ADtemp101=100*(sum+1)/(ADtemp110n-ADtemp1100);
			 LCD_DATA_DISPLAY1(ADtemp101);
		 }
	  }
	  Delay(0x2000);
}
/*----------------------------------------------------------------------------*/

void AD01(void)									//ADCƵ{
{
	unsigned char t;
	while(ok)									//ADC_OK=1
	{
		ok=0;
		ADtemp10=(ADCData>>17);

		value_buf[8]=value_buf[7];				//ưoiBz
		value_buf[7]=value_buf[6];
		value_buf[6]=value_buf[5];
		value_buf[5]=value_buf[4];
		value_buf[4]=value_buf[3];
		value_buf[3]=value_buf[2];
		value_buf[2]=value_buf[1];
		value_buf[1]=ADtemp10;
		sum=0;
		for(t=4;t>0;t--)
		{
			sum+=value_buf[t];
		}
		average=sum>>2;
	}
	if(average<0) average*=-1;
	sum=average;
}

/*
void AD01(void)														//ADƵ{
{
	int t;
	sum=0;
	for(t=0;t<8;t++)												//32bitiӫAk17
	{
		ADtemp10=(ADCData>>17);
		sum=sum+ADtemp10;
	}
	sum=sum>>3;														//8
	if(sum<0)														//
	{
		sum*=-1;
	}
}
*/
/*----------------------------------------------------------------------------*/
void AD3(void)														//tPwƵ{
{
	int t;
	sum=0;
	for(t=0;t<8;t++)												//NADJ8
	{
		ADtemp10=(ADCData>>18);
		sum+=ADtemp10;
	}
	if(sum>=-30)													//{pJPw
	{
		if(ch==0)													//e@Pw
		{
			nu=0;													//ثeJ
			ch=0;
			DrvADC_SetADCInputChannel(ADC_Input_AIO1,ADC_Input_AIO0);//AIO0BAIO1`tm
			goto by;												 //}{
		}
		if(ch==1)													 //e@Pwt
		{
			nu=1;													 //ثeJt
			ch=1;
			DrvADC_SetADCInputChannel(ADC_Input_AIO0,ADC_Input_AIO1);//AIO0BAIO1A˶O
			goto by;
		}
	}
	if(sum<0)														//{pJPw
	{
		if(ch==0)													//e@J
		{
			nu=1;													//{pPwt
			ch=1;
			DrvADC_SetADCInputChannel(ADC_Input_AIO0,ADC_Input_AIO1);//AIO0BAIO1A˰tm
			goto by;
		}
		if(ch==1)													//e@`t
		{
			nu=0;													//{pPw
			ch=0;
			DrvADC_SetADCInputChannel(ADC_Input_AIO1,ADC_Input_AIO0);//AIO0BAIO1`tm
			goto by;
		}
	}
	by:asm("NOP");
	Delay(0x8000);
}
/*---------------------------------------------------------------------------*/
/* Hardware Communication Interrupt                                          */
/* UART/SPI/I2C Interrupt Service Routines                                   */
/*---------------------------------------------------------------------------*/
void HW0_ISR(void)
{
  unsigned char I2C_Status;

  if(DrvI2C_ReadIntFlag()==E_DRVI2C_INT)  // Get I2C Interrupt Flag
  {
    I2C_Status=DrvI2C_GetStatusFlag();  // Get I2C Status Flag
    switch(I2C_Status)
    {
      case 0x90: //MACTFlag+RWFlag
          { /* START has been transmitted */
            DrvI2C_WriteData(I2C_TARGET);  //Send Slave Address & R/W Bit
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            break;
          };
      case 0x84: //MACTFlag+ACKFlag
          { /* Slave A + W has been transmitted. ACK has been received. */
            DrvI2C_WriteData(Sendbuf[DataTxIndex++]);  //Send Data to Slave
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            break;
          };
      case 0x80: //MACTFlag
          { /* Slave A + W has been transmitted. ACK has been received. */
            DrvI2C_WriteData(Sendbuf[DataTxIndex++]);  //Send Data to Slave
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            break;
          };
      case 0x30:
          {
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            EndFlag=1;
            break;
          };
      case 0x8C: // MACTFlag+DFFlag+ACKFlag
          { /* DATA has been transmitted and ACK has been received */
            if(DataTxIndex<DataTxLen)
            {
              DrvI2C_WriteData(Sendbuf[DataTxIndex++]);  //Send Data to Slave
              DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            }
            else
            {
              if(I2C_RW == WRITE)
              {
                DrvI2C_Ctrl(0,1,0,0);  // I2C as master sends STOP signal
                EndFlag=1;
              }
              else if(I2C_RW == READ)
                DrvI2C_Ctrl(1,0,0,0);  // I2C as master sends START signal
              DataTxIndex=0;
            }
            break;
          };
      case 0x88: //MACTFlag+DFFlag
          { /* DATA has been transmitted and NACK has been received */
            DrvI2C_Ctrl(0,1,0,0);  // I2C as master sends STOP signal
            DataTxIndex=0;
            EndFlag=1;
            break;
          };
      case 0xB0:
          { /* A repeated START has been transmitted. */
            DrvI2C_WriteData(I2C_TARGET | READ);  //Send Slave Address & R/W Bit
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            break;
          }
      case 0x94: //MACTFlag+RWFlag
          { /* Slave A + R has been transmitted. ACK has been received. */
            DrvI2C_Ctrl(0,0,0,1);  // Set ACK bit
            break;
          };
      case 0x9C: //MACTFlag+RWFlag+DFFlag+ACKFlag
          { /* Data byte has been received. ACK has been transmitted. */
            if(DataRxLen>DataRxIndex)
            {
              Recbuf[DataRxIndex++]=DrvI2C_ReadData();
              DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            }
            else
            {
              Recbuf[DataRxIndex++]=DrvI2C_ReadData();
              DrvI2C_Ctrl(0,1,0,0);  // I2C as master sends STOP signal
              EndFlag=1;
            }
            break;
          };
      case 0x98: //MACTFlag+RWFlag+DFFlag
          { /* Data byte has been received. NACK has been transmitted. */
            DrvI2C_Ctrl(0,1,0,0);  // I2C as master sends STOP signal
            EndFlag=1;
            break;
          };
      default:
          {
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            EndFlag=1;
            break;
          };
    }
    DrvI2C_ClearEIRQ();
    DrvI2C_ClearIntFlag(2); // Clear I2C Interrupt Flag(I2CIF)
    SYS_EnableGIE(7,0x3F);       // Enable GIE(Global Interrupt)
  }
  if(DrvI2C_ReadIntFlag()==E_DRVI2C_ERROR_INT)  //Get I2C Error Interrupt Flag
  {
    EndFlag=1;
    DrvI2C_ClearIRQ();
    DrvI2C_ClearIntFlag(2); // Clear I2C Interrupt Flag(I2CEIF)
    DrvI2C_Ctrl(0,1,0,0);   // I2C as master sends STOP signal
    SYS_EnableGIE(7,0x3F);       // Enable GIE(Global Interrupt)
  }
}

/*---------------------------------------------------------------------------*/
/* WDT & RTC & Timer A/B/C Interrupt Service Routines                                         */
/*---------------------------------------------------------------------------*/
void HW1_ISR(void)
{

}

/*----------------------------------------------------------------------------*/
/* HW2 ADC Interrupt Subroutines                                              */
/*----------------------------------------------------------------------------*/
void HW2_ISR(void)
{
	DrvADC_ClearIntFlag();
	ADCData=adc_08;
	ok=1;
}

/*---------------------------------------------------------------------------*/
/* CMP/OPA Interrupt Service Routines                                            */
/*---------------------------------------------------------------------------*/
void HW3_ISR(void)
{

}

/*---------------------------------------------------------------------------*/
/* PT1 Interrupt Service Routines                                            */
/*---------------------------------------------------------------------------*/
void HW4_ISR(void)
{
	DrvGPIO_ClearIntFlag(E_PT1,0xc0);         //Clear PT1 interrupt flag
	  b=DrvGPIO_GetBit(E_PT1,6);
	  c=DrvGPIO_GetBit(E_PT1,7);

	  asm volatile("sethi $r0, 0xc0000");
	  asm volatile("ori  $r0, $r0, 0x003f");
	  asm volatile("mtsr $r0, $INT_MASK");
	  asm volatile("movi $r0, 0x70009");
	  asm volatile("mtsr $r0, $PSW");
}

/*---------------------------------------------------------------------------*/
/* PT2 Interrupt Service Routines                                            */
/*---------------------------------------------------------------------------*/
void HW5_ISR(void)
{

}

/*---------------------------------------------------------------------------*/
/* Software Delay Subroutines                                                */
/*---------------------------------------------------------------------------*/
void Delay(unsigned int num)
{
  for(;num>0;num--)
    asm("NOP");
}
void InitalADC(void)
{
  //Set ADC input pin
  DrvADC_SetADCInputChannel(ADC_Input_AIO1,ADC_Input_AIO0);//ADC Input
  DrvADC_InputSwitch(OPEN);
  DrvADC_RefInputShort(OPEN);
  DrvADC_Gain(0,0);          //Set the ADC Gain
  DrvADC_DCoffset(0);        //DC offset input voltage selection
  DrvADC_RefVoltage(VDDA,0); //Set the ADC reference voltage.
  DrvADC_FullRefRange(1);    //Set the ADC reference range select.
                             //0:Full reference range input
                             //1:1/2 reference range input
  DrvADC_OSR(0);             //0:OSR=32768
  DrvADC_CombFilter(Enable);
  DrvADC_ClkEnable(0,1);     //Setting ADC CLOCK ADCK=HS_CK/6
  DrvPMU_VDDA_Voltage(E_VDDA2_4);
  DrvPMU_VDDA_LDO_Ctrl(E_LDO);
  DrvPMU_BandgapEnable();
  DrvPMU_REFO_Enable();
  DrvPMU_AnalogGround(Enable);//ADC analog ground source selection.
                              //1:Enable buffer and use internal source
  DrvPMU_LDO_LowPower(0);     //VDD LDO with low power control.
                              //0 : Normal;1 : Low power
  Delay(0x1000);
  //Set ADC interrupt
  DrvADC_EnableInt();
  DrvADC_ClearIntFlag();
  DrvADC_Enable();
}
void Initial_ALL(void)
{
	pio_00=0xff00ff00;						//ҦIO
	pio_04=0xff00ff00;
	pio_08=0x00;
	pio_10=0xff00ff03;
	pio_14=0xff00ff03;
	DrvGPIO_Open(E_PT1,0xc0,E_IO_INPUT);	//PT_6-7input
	DrvGPIO_Open(E_PT1,0xc0,E_IO_PullHigh); //enable PT1_6-7 pull high R

	SYS_EnableGIE(7,0x3f);                         //Enable GIE (Global Interrupt Enable)
	DrvGPIO_ClearIntFlag(E_PT1,0xc0);         //clear PT1.6~7 interrupt flag

	DrvGPIO_ClkGenerator(E_HS_CK,1);          //GPIO CLK enable
	DrvGPIO_Open(E_PT1,0xc0,E_IO_IntEnable);  //PT1.6~7 interrupt enable
	DrvGPIO_IntTrigger(E_PT1,0xc0,E_N_Edge);  //PT1.6~7 interrupt  trigger method is negative edge
	DrvCLOCK_EnableHighOSC(E_INTERNAL,50);       // Select HAO 4MHz
	ADtemp200=0;
	ADtemp1100=0;
	ADtemp110n=1405;
	ADtemp110p=1405;
	ADtemp20n=7;
	ADtemp20p=7;
	nu=0;
	key_ck=0;
	tn=2;
	ch=0;

}
void Pb_7()									//Ƶ{
{
	if(c==0)
	{
		pb7=1;
		c=1;
		while(1)							//pUL}AhLk}
		{
			c=DrvGPIO_GetBit(E_PT1,7);
			if(c==1)break;
		}

	}
}
/*----------------------------------------------------------------------------*/
void Pb_6()
{
	if(b==0)
	{
		pb6=1;
		b=1;
		while(1)							//pUL}AhLk}
		{
			b=DrvGPIO_GetBit(E_PT1,6);
			if(b==1)break;
		}

	}
}
/*---------------------------------------------------------------------------*/
/* End Of File                                                               */
/*---------------------------------------------------------------------------*/
